/**
 * courbetan.java - jpq - 16/09/99 - 22/09/22
 * jdk1.2 - double-buffering
 * modification et ajout de main() le 10/01/18
 */

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import geo.*;

public class courbetan extends Panel implements MouseListener, MouseMotionListener {
	static final long serialVersionUID = 220922L;
	static Image img;
	static Graphics g;
	static Repere R, R1;
	static Pt O, C, I, K, L, T, N, P;
	static PointSurDroite J, O1;
	static Cercle Ce;
	static ArcDeCercle IM;
	static Droite xpx, ypy, xegal1;
	static PointSurCercle M;
	static Segment OT, OM, OC, OI, MC, TI, O1N, NP, TP;
	static CourbeFonction cf;
	static tan f;
	int Nperiodes = 0;
	double ap = 1.0;
	int gw, gh;
	int Xm, Ym;

	public courbetan() {
		setBackground (Color.WHITE);
		addMouseMotionListener (this);
		addMouseListener (this);
		Nperiodes = 0;
	}

	public void update (Graphics g1) {
		paint (g1);
	}

	private double arrondi (double d) {
		return Math.floor (d * 100.0) / 100.0;
	}

	public void paint (Graphics g1) {
		if (img == null || gw != getSize().width || gh != getSize().height) {
			gw = getSize().width;
			gh = getSize().height;
			img = createImage (gw, gh);
			g = img.getGraphics();

			R = new Repere (gw / 2, gh / 2, gw, gh, 0.25 * gh - 20.0, 0.25 * gh - 20.0);
			xpx = new Droite (0.0, 1.0, 0.0);
			ypy = new Droite (1.0, 0.0, 0.0);
			xegal1 = new Droite (1.0, 0.0, -1.0);
			Ce = new Cercle (0.0, 0.0, 1.0);
			O1 = new PointSurDroite (0.0, 0.0, xpx);
			M = new PointSurCercle (1.0, Ce);
			O = new Pt (0.0, 0.0);
			I = new Pt (1.0, 0.0);
			J = new PointSurDroite (0.0, 1.0, ypy);
			K = new Pt (- 1.0, 0.0);
			L = new Pt (0.0, -1.0);
			C = new Pt (M.x, 0.0);
			T = new Pt (1.0, M.y / M.x);
			N = new Pt (O1.x + 1.0, 0.0);
			P = new Pt (O1.x + 1.0, M.y / M.x);
			IM = new ArcDeCercle (0.0, 0.0, 1.0, 0.0, 1.0);
			OT = new Segment (O, T);
			OM = new Segment (O, M);
			OC = new Segment (O, C);
			OI = new Segment (O, I);
			MC = new Segment (M, C);
			TI = new Segment (T, I);
			TP = new Segment (T, P);
			O1N = new Segment (O1, N);
			NP = new Segment (N, P);
			f = new tan();
			R1 = new Repere (R.X(O1.x), R.Y(O1.y), gw, gh, R.unitex, R.unitey);
			cf = new CourbeFonction (f);
		}
		Font f = new Font (Font.SANS_SERIF, Font.PLAIN, 10);
		g.setFont (f);
		g.setColor (getBackground());
		g.fillRect (0, 0, R.XMAX, R.YMAX);

		if (J.deplace) {
			if (J.y > 0.0) {
				double uy = (double) (R.Y0 - R.Y (J.y));
				R.MAJ (gw / 2, gh / 2, gw, gh, uy, uy);
			} else
				J.MAJ (0.0, 1.0);
			M.MAJ();
//			I.MAJ();
//			K.MAJ();
//			L.MAJ();
//			O1.MAJ (R.x (O1.X), R.y (O1.Y));
		}
		if (J.deplace || O1.deplace)
			R1.MAJ (R.X(O1.x), R.Y(O1.y), gw, gh, R.unitex, R.unitey);
		C.MAJ (M.x, 0.0);
		double Ma = M.a + Math.PI * (double) (2 * Nperiodes);
		IM.MAJ (0.0, 0.0, 1.0, 0.0, Ma);
		N.MAJ (O1.x + Ma, 0.0);
		if (M.x == O.x)
			T.defini = P.defini = false;
		else {
			double MydMx = M.y / M.x;
			T.MAJ (1.0, MydMx);
			P.MAJ (O1.x + Ma, MydMx);
		}
		OT.MAJ (O, T);
		OM.MAJ (O, M);
		OC.MAJ (O, C);
		MC.MAJ (M, C);
		TI.MAJ (T, I);
		TP.MAJ (T, P);
		NP.MAJ (N, P);
		O1N.MAJ (O1, N);

		g.setColor (Color.BLACK);
		g.drawString ("(" + Double.toString (arrondi(R1.x (Xm))) + ", " + Double.toString (arrondi(R1.y (Ym))) + ")", 2, gh - 20);

		g.setColor (Color.RED);
		cf.trace ("", R1, g);

		g.setColor (Color.MAGENTA);
		R.trace (g);
		R1.trace (g);
		O.traceNom ("O", R, g);

		g.setColor (Color.RED);
		O1.trace ("O1", R, g);
		J.trace ("J", R, g);
		M.trace ("M", R, g);

		g.setColor (Color.BLUE);
		Ce.trace ("", R, g);
		I.traceNom ("I", R, g);
		K.traceNom ("K", R, g);
		L.traceNom ("L", R, g);

		g.setColor (Color.GREEN);
		T.traceNom ("T", R, g);
		I.traceNom ("I", R, g);
		C.traceNom ("C", R, g);
		N.traceNom ("N", R, g);
		OT.trace ("", R, g);
		OM.trace ("", R, g);
		OC.trace ("", R, g);
		OI.trace ("", R, g);
		MC.trace ("", R, g);
		TI.trace ("", R, g);
		NP.trace ("", R, g);

		g.setColor (Color.CYAN);
		TP.trace ("", R, g);

		g.setColor (Color.BLACK);
//		R.cadre (g);
		P.trace ("P", R, g);
		IM.trace ("", R, g);
		O1N.trace ("", R, g);

		g1.drawImage (img, 0, 0, this);
	}

	public void mousePressed (MouseEvent e) {
		int X = e.getX();
		int Y =  e.getY();
		if (M.zone (X, Y, R) || J.zone (X, Y, R) || O1.zone (X, Y, R)) {
		}
	}

	public void mouseDragged (MouseEvent e) {
		int X = e.getX();
		int Y = e.getY();
		M.bouge (X, Y, R);
		if (M.a * ap < 0.0)
			if (ap > 2.0)
				Nperiodes ++;
			else if (ap < -2.0)
				Nperiodes --;
		ap = M.a;
		J.bouge (X, Y, R);
		O1.bouge (X, Y, R);
		repaint ();
	}

	public void mouseReleased (MouseEvent e) {
		M.deplace = J.deplace = O1.deplace = false;;
	}

	public void mouseMoved (MouseEvent e) {
		int X = Xm = e.getX();
		int Y = Ym = e.getY();
		if (M != null && M.zone (X, Y, R) || J != null && J.zone (X, Y, R) || O1 != null && O1.zone (X, Y, R)) {
			setCursor (new Cursor (Cursor.HAND_CURSOR));
		} else {
			setCursor (new Cursor (Cursor.DEFAULT_CURSOR));
		}
		repaint();
	}

	public void mouseClicked (MouseEvent e) {}
	public void mouseEntered (MouseEvent e) {}
	public void mouseExited (MouseEvent e) {}

	public static void main (String [] args) {
		courbetan t = new courbetan();
		JFrame f = new JFrame ("Courbe de la fonction tan");
		f.setDefaultCloseOperation (JFrame.DISPOSE_ON_CLOSE);
		f.add (t);
		f.setSize (600, 400);
		f.setVisible (true);
	}

/**
 * Fonction tan
 */

protected class tan extends Fonction {
	public boolean defini (double x) {
		return (x * 2.0) % Math.PI != 0.0;
	}

	public double Image (double x) {
		return Math.tan (x);
	}
}

}
